﻿using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MemDataTable_CS
{
    public class MyGridToolTipCreationFilter : IUIElementCreationFilter
    {
        void IUIElementCreationFilter.AfterCreateChildElements(UIElement parent)
        {
            if (parent is CellUIElement)
            {
                var toolTipItem = parent.ToolTipItem;
                if (null != toolTipItem)
                {
                    parent.ToolTipItem = new MyCellToolTipItem(toolTipItem);
                }
            }
        }

        bool IUIElementCreationFilter.BeforeCreateChildElements(UIElement parent)
        {
            // Do nothing. 
            return false;
        }

        #region MyCellToolTipItem
        public class MyCellToolTipItem : IToolTipItem
        {
            private IToolTipItem baseToolTipItem;

            public MyCellToolTipItem(IToolTipItem baseToolTipItem)
            {
                this.baseToolTipItem = baseToolTipItem;
            }

            #region IToolTipItem Members

            public ToolTipInfo GetToolTipInfo(Point mousePosition, UIElement element, UIElement previousToolTipElement, ToolTipInfo toolTipInfoDefault)
            {
                // Create a new ToolTipInfo based on the values passed in. 
                ToolTipInfo newToolTipInfo = baseToolTipItem.GetToolTipInfo(mousePosition, element, previousToolTipElement, toolTipInfoDefault);

                // 0 means never automatically hide the tooltip (until the mouse
                // leaves the element). 
                newToolTipInfo.AutoPopDelay = 0;

                // Return the new tooltip info. 
                return newToolTipInfo;
            }

            #endregion
        }
        #endregion //MyCellToolTipItem
    }
}
